//! An `Oscillator` generates a base signal at a given frequency.

use ::components::Component;

use std::f64::consts::PI;

/// Describes the kind of wave generated by the oscillator.
pub enum Waveform {
    Sine,
    Square,
    Sawtooth,
}

pub struct Oscillator {
    waveform: Waveform,
    output_frequency: i32, // Frequency of the SDL output (44100 Hz by default)

    /// Frequency of the oscillating signal
    pub frequency: f32, 

    ticks: i32,
}

impl Oscillator {
    /// Create a new `Oscillator` for a SDL polling rate of `output_frequency`
    /// and a waveform `waveform`.
    pub fn new(output_frequency: i32, waveform: Waveform) -> Oscillator {
        Oscillator {
            waveform,
            output_frequency,

            frequency: 1.0,
            ticks: 0,
        }
    }
}

impl Component for Oscillator {
    fn tick(&mut self) {
        self.ticks = (self.ticks + 1) % ((self.output_frequency) / self.frequency as i32);
    }

    fn generate(&mut self, velocity: f32) -> f32 {
        let mut x = match self.waveform {
            Waveform::Sine => (2.0 * PI as f32 * self.ticks as f32 / ((self.output_frequency as f32) / self.frequency)).sin(),
            Waveform::Square => if self.ticks > ((self.output_frequency as f32) / self.frequency) as i32 / 2 {
                1.0
            } else {
                -1.0
            },
            Waveform::Sawtooth => self.ticks as f32 / ((self.output_frequency as f32) / self.frequency) - 0.5,
        };

        x *= velocity;

        x
    }
}
